#lang racket

(provide times3 9multiples sum-of-times10 count-ones)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; times3
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; times3
;;   inputs: a list L of integers
;;   outputs: a new list L' that contains the orginal elements of L,
;;            multiplied by 3
(define (times3 L)
  (map (lambda (n) (* 3 n)) L))



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; 9multiples
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; 9multiples
;;   inputs: a list of integers L
;;   outputs: a new list L' that contains only those elements of L that are
;;            divisible by 9
(define (9multiples L)
  (filter (lambda (n) (= (modulo n 9) 0)) L))



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; sum-of-times10
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; sum-of-times10
;;   inputs: a list of integers L
;;   outputs: a new list L' multiplies each element of a list L by 10,
;;            then sums the results
(define (sum-of-times10 L)
  (let ([times10 (map (lambda (x) (* x 10)) L)])
    (foldr + 0 times10)))



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; count-ones
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; count-ones
;;   inputs: a list of integers L
;;   outputs: the number of times that the value 1 appears in L
(define (count-ones L)
  (let ([only-ones (filter (lambda (x) (= x 1)) L)])
    (foldr (lambda (elem accum) (+ accum 1)) 0 only-ones)))


;(define (count-ones L)
;  (foldr (lambda (elem accum)
;            (+ accum (if (= elem 1) 1 0))) 0 L))
      
















(define (map f L)
  (if (empty? L)
      '()
      (cons (f (first L)) (map f (rest L)))))

(define (filter f L)
  (cond [(empty? L) '()]
        [(f (first L)) (cons (first L) (filter f (rest L)))]
        [else (filter f (rest L))]))

(define (foldl f accum L)
  (if (empty? L) 
      accum
      (foldl f (f (first L) accum) (rest L))))

(define (foldr f accum L)
  (if (empty? L)
      accum
      (f (first L) (foldr f accum (rest L)))))
